package com.ejie.ab79.dao.inspecciones;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.inspecciones.DesEstIns;
import com.ejie.ab79.model.inspecciones.EstadosInspeccion;
import com.ejie.ab79.model.inspecciones.OrigenesInspeccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * EstadosInspeccionDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class EstadosInspeccionDaoImpl implements EstadosInspeccionDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDESTADOINSPECCION",
			"ESTADODESCRIPCIONCASTELLANO", "ESTADODESCRIPCIONEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO",
			"DESNEUSORIGEN", "DESNESORIGEN", "DESNEUSDIREC", "DESNESDIREC" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<EstadosInspeccion> rwMap = new RowMapper<EstadosInspeccion>() {
		public EstadosInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			EstadosInspeccion estadosInspeccion = new EstadosInspeccion();
			estadosInspeccion.setIdEstadoInspeccion(resultSet.getLong("IDESTADOINSPECCION"));
			estadosInspeccion.setBaja(resultSet.getInt("BAJA"));
			estadosInspeccion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			estadosInspeccion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			DesEstIns desEstIns = new DesEstIns();
			desEstIns.setIdDesEstIns(resultSet.getLong("IDDESESTINS"));
			desEstIns.setDescripcionCastellano(resultSet.getString("ESTADODESCRIPCIONCASTELLANO"));
			desEstIns.setDescripcionEuskera(resultSet.getString("ESTADODESCRIPCIONEUSKERA"));

			estadosInspeccion.setDesEstIns(desEstIns);

			return estadosInspeccion;
		}
	};

	private RowMapper<EstadosInspeccion> rwMapFindAllLike = new RowMapper<EstadosInspeccion>() {
		public EstadosInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			EstadosInspeccion estadosInspeccion = new EstadosInspeccion();

			estadosInspeccion.setIdEstadoInspeccion(resultSet.getLong("IDESTADOINSPECCION"));
			estadosInspeccion.setBaja(resultSet.getInt("BAJA"));
			estadosInspeccion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			estadosInspeccion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DESNESDIREC"));
			direccion.setDescripcionEuskera(resultSet.getString("DESNEUSDIREC"));
			estadosInspeccion.setDireccion(direccion);

			OrigenesInspeccion origenesInspeccion = new OrigenesInspeccion();
			origenesInspeccion.setIdOrigenInspeccion(resultSet.getInt("IDORIGEN"));
			origenesInspeccion.setDescripcionCastellano(resultSet.getString("DESNESORIGEN"));
			origenesInspeccion.setDescripcionEuskera(resultSet.getString("DESNEUSORIGEN"));
			estadosInspeccion.setOrigenInspeccion(origenesInspeccion);

			DesEstIns desEstIns = new DesEstIns();
			desEstIns.setIdDesEstIns(resultSet.getLong("IDDESESTINS"));
			desEstIns.setDescripcionCastellano(resultSet.getString("ESTADODESCRIPCIONCASTELLANO"));
			desEstIns.setDescripcionEuskera(resultSet.getString("ESTADODESCRIPCIONEUSKERA"));
			estadosInspeccion.setDesEstIns(desEstIns);

			return estadosInspeccion;
		}
	};

	private RowMapper<EstadosInspeccion> rwMapFindAll = new RowMapper<EstadosInspeccion>() {
		public EstadosInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			EstadosInspeccion estadosInspeccion = new EstadosInspeccion();
			estadosInspeccion.setIdEstadoInspeccion(resultSet.getLong("IDESTADOINSPECCION"));
			estadosInspeccion.setBaja(resultSet.getInt("BAJA"));
			estadosInspeccion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			estadosInspeccion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			DesEstIns desEstIns = new DesEstIns();
			desEstIns.setIdDesEstIns(resultSet.getLong("IDDESESTINS"));
			desEstIns.setDescripcionCastellano(resultSet.getString("ESTADODESCRIPCIONCASTELLANO"));
			desEstIns.setDescripcionEuskera(resultSet.getString("ESTADODESCRIPCIONEUSKERA"));
			estadosInspeccion.setDesEstIns(desEstIns);

			OrigenesInspeccion origenInspeccionAux = new OrigenesInspeccion();
			origenInspeccionAux.setIdOrigenInspeccion(resultSet.getInt("IDORIGENINSPECCION"));
			estadosInspeccion.setOrigenInspeccion(origenInspeccionAux);

			Direcciones direccionAux = new Direcciones();
			direccionAux.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			estadosInspeccion.setDireccion(direccionAux);

			return estadosInspeccion;
		}
	};

	private RowMapper<EstadosInspeccion> rwMapPK = new RowMapper<EstadosInspeccion>() {
		public EstadosInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new EstadosInspeccion(resultSet.getLong("IDESTADOINSPECCION"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<EstadosInspeccion>> rwMapJerarquia = new RowMapper<JerarquiaDto<EstadosInspeccion>>() {
		public JerarquiaDto<EstadosInspeccion> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			EstadosInspeccion estadosinspeccion = new EstadosInspeccion();
			estadosinspeccion.setIdEstadoInspeccion(resultSet.getLong("IDESTADOINSPECCION"));
			estadosinspeccion.setBaja(resultSet.getInt("BAJA"));
			estadosinspeccion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			estadosinspeccion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<EstadosInspeccion> jerarquia = new JerarquiaDto<EstadosInspeccion>();
			jerarquia.setModel(estadosinspeccion);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	private RowMapper<EstadosInspeccion> rwMapIdsEstadosInspeccion = new RowMapper<EstadosInspeccion>() {
		public EstadosInspeccion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			EstadosInspeccion estadoInspeccion = new EstadosInspeccion();
			estadoInspeccion.setIdEstadoInspeccion(resultSet.getLong("IDESTADOINSPECCION"));

			return estadoInspeccion;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the EstadosInspeccion table.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @return EstadosInspeccion
	 */
	public EstadosInspeccion add(EstadosInspeccion estadosinspeccion) {

		int idEstadoinspeccion = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7906T00.NEXTVAL FROM DUAL",
				Integer.class);

		String query = "INSERT INTO ESTADOS_INSPECCION (ID_ESTADO_INSPECCION, BAJA, FECHA_REGISTRO, USUARIO_REGISTRO, ID_DIRECCION, ID_ORIGEN_INSPECCION, ID_DES_EST_INS) VALUES (?,?,SYSDATE,?,?,?,?)";
		this.jdbcTemplate.update(query, idEstadoinspeccion, Constantes.BAJA_NO, estadosinspeccion.getUsuarioRegistro(),
				estadosinspeccion.getDireccion().getIdDireccion(),
				estadosinspeccion.getOrigenInspeccion().getIdOrigenInspeccion(),
				estadosinspeccion.getDesEstIns().getIdDesEstIns());
		return estadosinspeccion;
	}

	/**
	 * Updates a single row in the EstadosInspeccion table.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @return EstadosInspeccion
	 */
	public EstadosInspeccion update(EstadosInspeccion estadosinspeccion) {
		String query = "UPDATE ESTADOS_INSPECCION SET ID_DIRECCION=?, ID_ORIGEN_INSPECCION=?, ID_DES_EST_INS=?,FECHA_ULTMODIFICACION=SYSDATE,USUARIO_ULTMODIFICACION=? WHERE ID_ESTADO_INSPECCION=?";
		this.jdbcTemplate.update(query, estadosinspeccion.getDireccion().getIdDireccion(),
				estadosinspeccion.getOrigenInspeccion().getIdOrigenInspeccion(),
				estadosinspeccion.getDesEstIns().getIdDesEstIns(), estadosinspeccion.getUsuarioUltimaModificacion(),
				estadosinspeccion.getIdEstadoInspeccion());
		return estadosinspeccion;
	}

	/**
	 * Finds a single row in the EstadosInspeccion table.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @return EstadosInspeccion
	 */
	@Transactional(readOnly = true)
	public EstadosInspeccion find(EstadosInspeccion estadosinspeccion) {
		String query = "SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION, t1.BAJA BAJA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.ID_ORIGEN_INSPECCION IDORIGEN, t2.DESCRIPCION_CASTELLANO DESNESDIREC,t2.DESCRIPCION_EUSKERA DESNEUSDIREC, t3.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_EUSKERA DESNEUSORIGEN, t3.DESCRIPCION_CASTELLANO DESNESORIGEN, t4.ID_DES_EST_INS IDDESESTINS, t4.DESCRIPCION_CASTELLANO ESTADODESCRIPCIONCASTELLANO, t4.DESCRIPCION_EUSKERA ESTADODESCRIPCIONEUSKERA FROM ESTADOS_INSPECCION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_EST_INS t4  WHERE t1.ID_ESTADO_INSPECCION = ? AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND T1.ID_DES_EST_INS = t4.ID_DES_EST_INS ";

		List<EstadosInspeccion> estadosinspeccionList = this.jdbcTemplate.query(query, this.rwMapFindAllLike,
				estadosinspeccion.getIdEstadoInspeccion());
		return DataAccessUtils.uniqueResult(estadosinspeccionList);
	}

	/**
	 * Finds a single row in the EstadosInspeccion table.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @return EstadosInspeccion
	 */
	@Transactional(readOnly = true)
	public EstadosInspeccion findDatosBasicos(EstadosInspeccion estadosinspeccion) {
		String query = "SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION, t1.BAJA BAJA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.ID_DES_EST_INS IDDESESTINS, t2.DESCRIPCION_CASTELLANO ESTADODESCRIPCIONCASTELLANO, t2.DESCRIPCION_EUSKERA ESTADODESCRIPCIONEUSKERA FROM ESTADOS_INSPECCION t1, DES_EST_INS t2 WHERE t1.ID_DES_EST_INS = t2.ID_DES_EST_INS AND t1.ID_ESTADO_INSPECCION = ?";

		List<EstadosInspeccion> estadosinspeccionList = this.jdbcTemplate.query(query, this.rwMap,
				estadosinspeccion.getIdEstadoInspeccion());
		return DataAccessUtils.uniqueResult(estadosinspeccionList);
	}

	@Override
	public Integer findRegistroDuplicado(EstadosInspeccion estadosInspeccion) {
		String query = "SELECT COUNT(1) FROM ESTADOS_INSPECCION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_EST_INS t4 WHERE t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t1.ID_DES_EST_INS = t4.ID_DES_EST_INS AND t2.ID_ORIGEN_INSPECCION = ? AND t3.ID_DIRECCION = ? AND t4.ID_DES_EST_INS = ? AND t1.BAJA = ?";
		List<Object> params = new ArrayList<Object>();
		params.add(estadosInspeccion.getOrigenInspeccion().getIdOrigenInspeccion());
		params.add(estadosInspeccion.getDireccion().getIdDireccion());
		params.add(estadosInspeccion.getDesEstIns().getIdDesEstIns());
		params.add(Constantes.BAJA_NO); 
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	@Override
	public EstadosInspeccion findByOrigenDireccion(Integer idOrigenInspeccion, Integer idDireccion, Integer estado) {
		String query = "SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION FROM ESTADOS_INSPECCION t1 WHERE t1.ID_ORIGEN_INSPECCION = ? AND t1.ID_DIRECCION = ? AND t1.ID_DES_EST_INS = ?";

		List<EstadosInspeccion> estadosInspeccion = this.jdbcTemplate.query(query, this.rwMapPK, idOrigenInspeccion,
				idDireccion, estado);
		return DataAccessUtils.uniqueResult(estadosInspeccion);
	}

	@Override
	public List<EstadosInspeccion> findByDesEstIns(List<String> idsDesEstIns) {
		String condicion = "";
		for (int i = 0; i < idsDesEstIns.size(); i++) {
			condicion = condicion + "?,";
		}
		if (condicion.length() > 0) {
			condicion = condicion.substring(0, condicion.length() - 1);
		}
		String query = "SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION FROM ESTADOS_INSPECCION t1 WHERE t1.ID_DES_EST_INS IN ("
				+ condicion + ")";

		List<Object> params = new ArrayList<Object>();

		for (int i = 0; i < idsDesEstIns.size(); i++) {
			params.add(idsDesEstIns.get(i));
		}

		return this.jdbcTemplate.query(query, this.rwMapIdsEstadosInspeccion, params.toArray());
	}

	/**
	 * Removes a single row in the EstadosInspeccion table.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @return
	 */
	public void remove(EstadosInspeccion estadosinspeccion) {
		String query = "UPDATE ESTADOS_INSPECCION SET BAJA=?, FECHA_ULTMODIFICACION=SYSDATE, USUARIO_ULTMODIFICACION=? WHERE ID_ESTADO_INSPECCION=?";
		this.jdbcTemplate.update(query, 1, estadosinspeccion.getUsuarioRegistro(),
				estadosinspeccion.getIdEstadoInspeccion());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<EstadosInspeccion> getMultiple(EstadosInspeccion filterEstadosInspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterEstadosInspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, EstadosInspeccion.class,
				params, "ID_ESTADO_INSPECCION");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the EstadosInspeccion table.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<EstadosInspeccion>
	 */
	@Transactional(readOnly = true)
	public List<EstadosInspeccion> findAll(EstadosInspeccion estadosinspeccion, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.ID_DES_EST_INS IDDESESTINS, t2.DESCRIPCION_CASTELLANO ESTADODESCRIPCIONCASTELLANO, t2.DESCRIPCION_EUSKERA ESTADODESCRIPCIONEUSKERA");
		query.append(", t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.ID_DIRECCION IDDIRECCION");
		query.append(" FROM ESTADOS_INSPECCION t1, DES_EST_INS t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(estadosinspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 AND t1.ID_DES_EST_INS = t2.ID_DES_EST_INS ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					EstadosInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMapFindAll, params.toArray());
	}

	/**
	 * Finds rows in the EstadosInspeccion table using like.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<EstadosInspeccion>
	 */
	@Transactional(readOnly = true)
	public List<EstadosInspeccion> findAllLike(EstadosInspeccion estadosinspeccion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.ID_ORIGEN_INSPECCION IDORIGEN, t2.DESCRIPCION_EUSKERA DESNEUSORIGEN, t2.DESCRIPCION_CASTELLANO DESNESORIGEN, t3.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_EUSKERA DESNEUSDIREC, t3.DESCRIPCION_CASTELLANO DESNESDIREC, t4.ID_DES_EST_INS IDDESESTINS, t4. DESCRIPCION_CASTELLANO ESTADODESCRIPCIONCASTELLANO, t4.DESCRIPCION_EUSKERA ESTADODESCRIPCIONEUSKERA ");
		query.append("FROM ESTADOS_INSPECCION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_EST_INS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMapFindAll(estadosinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					EstadosInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return this.jdbcTemplate.query(query.toString(), this.rwMapFindAllLike, params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the EstadosInspeccion table.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(EstadosInspeccion estadosinspeccion) {
		StringBuilder query = new StringBuilder("SELECT COUNT(1) FROM ESTADOS_INSPECCION t1 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(estadosinspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the EstadosInspeccion table using like.
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(EstadosInspeccion estadosinspeccion, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM ESTADOS_INSPECCION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_EST_INS t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMapFindAll(estadosinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of EstadosInspeccion selected for rup_table
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EstadosInspeccion>>
	 */
	@Override
	public List<TableRowDto<EstadosInspeccion>> reorderSelection(EstadosInspeccion estadosinspeccion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ESTADOS_INSPECCION t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(estadosinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				EstadosInspeccion.class, filterParamList, "ID_ESTADO_INSPECCION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<EstadosInspeccion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            EstadosInspeccion
	 * @param searchParams
	 *            EstadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<EstadosInspeccion>>
	 */
	@Override
	public List<TableRowDto<EstadosInspeccion>> search(EstadosInspeccion filterParams, EstadosInspeccion searchParams,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ESTADOS_INSPECCION t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				EstadosInspeccion.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_ESTADO_INSPECCION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<EstadosInspeccion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterestadosinspeccion
	 *            EstadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(EstadosInspeccion filterestadosinspeccion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM ESTADOS_INSPECCION t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterestadosinspeccion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				EstadosInspeccion.class, query, params, "ID_ESTADO_INSPECCION");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical EstadosInspeccion table.
	 *
	 * @param filterEstadosInspeccion
	 *            EstadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<EstadosInspeccion>>
	 */
	@Override
	public List<JerarquiaDto<EstadosInspeccion>> findAllLikeJerarquia(EstadosInspeccion filterEstadosInspeccion,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM ESTADOS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("ESTADOS_INSPECCION");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterEstadosInspeccion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_ESTADO_INSPECCION", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		if (tableRequestDto != null) {
			query = TableManagerJerarquia.getPaginationQuery(tableRequestDto, query,
					EstadosInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterEstadosInspeccion
	 *            EstadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(EstadosInspeccion filterEstadosInspeccion, TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM ESTADOS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("ESTADOS_INSPECCION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterEstadosInspeccion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_ESTADO_INSPECCION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterEstadosInspeccion
	 *            EstadosInspeccion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<EstadosInspeccion>>
	 */
	@Override
	public List<TableRowDto<EstadosInspeccion>> findAllChild(EstadosInspeccion filterEstadosInspeccion,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM ESTADOS_INSPECCION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("ESTADOS_INSPECCION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterEstadosInspeccion, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere, "ID_ESTADO_INSPECCION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<EstadosInspeccion>(this.rwMapPK, "ID_ESTADO_INSPECCION"),
				params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the EstadosInspeccion entity
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion Bean with the criteria values to filter by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(EstadosInspeccion estadosinspeccion) {

		StringBuilder where = new StringBuilder(EstadosInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (estadosinspeccion != null && estadosinspeccion.getIdEstadoInspeccion() != null) {
			where.append(" AND t1.ID_ESTADO_INSPECCION = ?");
			params.add(estadosinspeccion.getIdEstadoInspeccion());
		}
		if (estadosinspeccion != null && estadosinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(estadosinspeccion.getFechaRegistro());
		}
		if (estadosinspeccion != null && estadosinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(estadosinspeccion.getUsuarioRegistro());
		}

		if (estadosinspeccion != null && estadosinspeccion.getBaja() != null) {
			where.append(" AND (t1.BAJA = ? OR t1.BAJA IS NULL)");
			params.add(estadosinspeccion.getBaja());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	private Map<String, ?> getWhereMapDatosBasicos(EstadosInspeccion estadosinspeccion) {

		StringBuilder where = new StringBuilder(EstadosInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (estadosinspeccion != null && estadosinspeccion.getIdEstadoInspeccion() != null) {
			where.append(" AND t1.ID_ESTADO_INSPECCION = ?");
			params.add(estadosinspeccion.getIdEstadoInspeccion());
		}
		if (estadosinspeccion != null && estadosinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(estadosinspeccion.getFechaRegistro());
		}
		if (estadosinspeccion != null && estadosinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(estadosinspeccion.getUsuarioRegistro());
		}

		where.append(
				" AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DES_EST_INS = t3.ID_DES_EST_INS AND t2.ID_INSPECCION = "
						+ estadosinspeccion.getIdInspeccion());
		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	private Map<String, ?> getWhereMapFindAll(EstadosInspeccion estadosinspeccion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(EstadosInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		where.append(
				" AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t1.ID_DES_EST_INS = t4.ID_DES_EST_INS ");

		if (estadosinspeccion != null && estadosinspeccion.getIdEstadoInspeccion() != null) {
			where.append(" AND t1.ID_ESTADO_INSPECCION = ?");
			params.add(estadosinspeccion.getIdEstadoInspeccion());
		}
		if (estadosinspeccion != null && estadosinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(estadosinspeccion.getFechaRegistro());
		}
		if (estadosinspeccion != null && estadosinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(estadosinspeccion.getUsuarioRegistro());
		}
		if (estadosinspeccion != null && estadosinspeccion.getDireccion() != null
				&& estadosinspeccion.getDireccion().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(estadosinspeccion.getDireccion().getIdDireccion());
		}
		if (estadosinspeccion != null && estadosinspeccion.getDesEstIns() != null
				&& estadosinspeccion.getDesEstIns().getIdDesEstIns() != null) {
			where.append(" AND t1.ID_DES_EST_INS = ?");
			params.add(estadosinspeccion.getDesEstIns().getIdDesEstIns());
		}
		if (estadosinspeccion != null && estadosinspeccion.getOrigenInspeccion() != null
				&& estadosinspeccion.getOrigenInspeccion().getIdOrigenInspeccion() != null) {
			where.append(" AND t1.ID_ORIGEN_INSPECCION = ?");
			params.add(estadosinspeccion.getOrigenInspeccion().getIdOrigenInspeccion());
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the EstadosInspeccion entity
	 *
	 * @param estadosinspeccion
	 *            EstadosInspeccion Bean with the criteria values to filter by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(EstadosInspeccion estadosinspeccion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(EstadosInspeccionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (estadosinspeccion != null && estadosinspeccion.getIdEstadoInspeccion() != null) {
			where.append(" AND t1.ID_ESTADO_INSPECCION = ?");
			params.add(estadosinspeccion.getIdEstadoInspeccion());
		}
		if (estadosinspeccion != null && estadosinspeccion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(estadosinspeccion.getFechaRegistro());
		}
		if (estadosinspeccion != null && estadosinspeccion.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(estadosinspeccion.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + estadosinspeccion.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;

	@Transactional(readOnly = true)
	public List<EstadosInspeccion> findAllDatosInspeccion(EstadosInspeccion estadosinspeccion,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t3.ID_DES_EST_INS IDDESESTINS, t3.DESCRIPCION_CASTELLANO ESTADODESCRIPCIONCASTELLANO, t3.DESCRIPCION_EUSKERA ESTADODESCRIPCIONEUSKERA ");
		query.append("FROM ESTADOS_INSPECCION t1, INSPECCIONES t2, DES_EST_INS t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMapDatosBasicos(estadosinspeccion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query,
					EstadosInspeccionDaoImpl.ORDER_BY_WHITE_LIST);
		}

		return (List<EstadosInspeccion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<EstadosInspeccion> findByDesEstIns(DesEstIns desEstIns) {
		String query = "SELECT t1.ID_ESTADO_INSPECCION IDESTADOINSPECCION FROM ESTADOS_INSPECCION t1 WHERE t1.ID_DES_EST_INS = ? ";

		return this.jdbcTemplate.query(query, this.rwMapPK, desEstIns.getIdDesEstIns());
	}
}
